## Running GtkGLExt Applications Running GtkGLExt Applications — How to run and debug your GtkGLExt application |

## Running and debugging GtkGLExt Applications

### Common command line options

All GtkGLExt applications support the following command line options. These are removed from `argv` by gtk_gl_init().

`--gtk-gl-install-colormap`. Install OpenGL window's colormap to the top-level window. If window manager doesn't watch the WM_COLORMAP_WINDOWS property on the top-level window, we have to set OpenGL window's colormap to the top-level window, especially in color index mode (color index mode uses own private colormap).

`--gtk-gl-debug `options``. A list of debug options to turn on in addition to those specified in the `GTK_GL_DEBUG` environment variable. This option is only available if GtkGLExt has been configured with `--enable-debug=yes`.

`--gtk-gl-no-debug `options``. A list of debug options to turn off. This option is only available if GtkGLExt has been configured with `--enable-debug=yes`.

The following options are really used by GdkGLExt library.

`--gdk-gl-no-standard-colormap`. This option disables GdkGLExt library to find a standard RGB colormap using XmuLookupStandardColormap(). If your application gets a BadColor X Window System error, try this option. On Solaris 2.4 and 2.5, they have a bug in XmuLookupStandardColormap() implementation. If your application gets a BadMatch X Window System error from XCreateWindow(), pass this option to avoid using broken XmuLookupStandardColormap(). Sun fixed this bug in Solaris 2.6.

`--gdk-gl-force-indirect`. Users can force GdkGLExt library to use indirect rendering context. If your application has a problem with hardware acceleration, try this option.

`--gdk-gl-debug `options``. A list of debug options to turn on in addition to those specified in the `GDK_GL_DEBUG` environment variable. This option is only available if GtkGLExt has been configured with `--enable-debug=yes`.

`--gdk-gl-no-debug `options``. A list of debug options to turn off. This option is only available if GtkGLExt has been configured with `--enable-debug=yes`.

### Environment variables

GtkGLExt inspects the following environment variables.

`GTK_GL_INSTALL_COLORMAP`. If this variable is set to 1, GtkGLExt will try to install colormap to the top-level window. If window manager doesn't watch the WM_COLORMAP_WINDOWS property on the top-level window, we have to set OpenGL window's colormap to the top-level window.

`GTK_GL_DEBUG`. If GtkGLExt has been configured with `--enable-debug=yes`, this variable can be set to a list of debug options, which cause GtkGLExt library to print out different types of debugging information.

misc | Miscellaneous information
func | Show function call information

The special value `all` can be used to turn on all debug options.

`GDK_GL_NO_STANDARD_COLORMAP`. If this variable is set to 1, GdkGLExt library doesn't try to find a standard RGB colormap using XmuLookupStandardColormap(). If your application gets a BadColor X Window System error, try to set this environment variable. On Solaris 2.4 and 2.5, they have a bug in XmuLookupStandardColormap() implementation. If your application gets a BadMatch X Window System error from XCreateWindow(), set this environment variable to avoid using broken XmuLookupStandardColormap(). Sun fixed this bug in Solaris 2.6.

`GDK_GL_FORCE_INDIRECT`. If this variable is set to 1, GdkGLExt library uses indirect rendering context. If your application has a problem with hardware acceleration, try to set this environment variable.

`GDK_GL_DEBUG`. If GtkGLExt has been configured with `--enable-debug=yes`, this variable can be set to a list of debug options, which cause GdkGLExt library to print out different types of debugging information.

misc | Miscellaneous information
func | Show function call information
impl | Show window system specific (GLX, WGL) function call information

The special value `all` can be used to turn on all debug options.